from VerificationCode.mcbbs.SignIn import main_sign_in
from VerificationCode.mcbbs.reply import reply
from timing.time import set_time
from VerificationCode.mcbbs.task import get_new_tasks, complete_tasks
from selenium import webdriver
from loginTools.login import login
from loginTools.include_all_cookies import include_all_cookies
import time
import threading


def main():
    threads = [threading.Thread(target=main_reply), threading.Thread(target=main_tasks_and_sign)]
    for t in threads:
        t.start()
        print(t)


def main_reply():
    while True:
        set_time(one_reply, None, " 08:00:00")
        set_time(one_reply, None, " 12:00:00")
        set_time(one_reply, None, " 14:00:00")
        set_time(one_reply, None, " 16:00:00")
        set_time(one_reply, None, " 18:00:00")
        set_time(one_reply, None, " 22:00:00")
        time.sleep(86400)


def one_reply():
    driver = webdriver.Chrome()
    cookies = include_all_cookies()
    for cookie_path in cookies:
        if not login(driver, cookie_path):
            continue
        time.sleep(10)
        reply(driver,
              'https://www.mcbbs.net/forum.php?mod=forumdisplay&fid=52&orderby=heats&filter=dateline&dateline=604800')
        i = 2
        while i >= 1:
            time.sleep(10)
            reply(driver, 'https://www.mcbbs.net/forum-mod-1.html')
            i = i - 1
    driver.quit()


def main_tasks_and_sign():
    while True:
        tasks()
        time.sleep(86400)


def tasks():
    driver_another = webdriver.Firefox()
    set_time(get_tasks_and_sign_in, (driver_another,), " 07:30:00")
    set_time(final_complete_tasks, (driver_another,), " 19:30:00")


def get_tasks_and_sign_in(driver):
    cookies = include_all_cookies()
    for cookie_path in cookies:
        if not login(driver, cookie_path):
            continue
        main_sign_in(driver)
        get_new_tasks(driver)


def final_complete_tasks(driver):
    cookies = include_all_cookies()
    for cookie_path in cookies:
        if not login(driver, cookie_path):
            continue
        complete_tasks(driver)


if __name__ == '__main__':
    main()
